# Create MicroBlaze Vivado IPI project
source data/bd.tcl
validate_bd_design
save_bd_design

# Create wrapper
make_wrapper -files [get_files design_1.bd] -top
add_files -norecurse project_1/project_1.srcs/sources_1/bd/design_1/hdl/design_1_wrapper.v

# Generate output products
generate_target synthesis [get_files design_1.bd] -quiet

# Export hardware
file mkdir project_1/project_1.sdk
write_hwdef -file project_1/project_1.sdk/design_1_wrapper.hdf

# Create software
exec xsct data/xsct.tcl project_1/project_1.sdk repo >& xsct.log

# Associate ELF file
set elf_filename project_1/project_1.sdk/static_data_ex/Debug/static_data_ex.elf
add_files -fileset sources_1 -norecurse -force $elf_filename
add_files -fileset sim_1 -norecurse -force $elf_filename
set_property SCOPED_TO_REF design_1 [get_files -all -of_objects [get_fileset sources_1] $elf_filename]
set_property SCOPED_TO_CELLS { microblaze_0 } [get_files -all -of_objects [get_fileset sources_1] $elf_filename]

# Build hardware
launch_runs impl_1 -to_step write_bitstream
wait_on_run impl_1
